unit EnLabel;  {$R EnLabel.DCR}

interface

uses
  Controls, StdCtrls, classes;

type
  TPropertyLookupWhere = (pl_Parent,pl_Linked,pl_InDesignAlso);
  TPropertyLookup = set of TPropertyLookupWhere;
  TGetEnabledEvent = procedure( Sender: TObject; var Enabled: boolean) of object;

  TEnLabel = class(tlabel)
  private
    FEnablingMode: TPropertyLookup;
    FOnGetEnabled: TGetEnabledEvent;
    function GetFEnabled: boolean;
    { Private declarations }
  protected
    { Protected declarations }
    function GetEnabled: Boolean; override;
  public
    { Public declarations }
    property ItselfEnabled: boolean read GetFEnabled;
    constructor Create ( AOwner: TComponent); override;
  published
    { Published declarations }
    property EnablingMode: TPropertyLookup read FEnablingMode write FEnablingMode default [pl_Parent];
    property OnGetEnabled: TGetEnabledEvent read FOnGetEnabled write FOnGetEnabled default nil;
  end;

procedure Register;

implementation 

procedure Register;
begin
  RegisterComponents('Extra', [TEnLabel]);
end;

{ TEnLabel }

constructor TEnLabel.Create(AOwner: TComponent);
begin
  inherited;
  FOnGetEnabled := nil;
  EnablingMode := [pl_Parent];
end;

function TEnLabel.GetEnabled: Boolean;
begin
  Result := ItselfEnabled;
  if (pl_InDesignAlso in EnablingMode) or not (csDesigning in ComponentState) then begin
    if pl_Linked in EnablingMode then if FocusControl<>nil
       then Result := Result and FocusControl.Enabled;
    if pl_Parent in EnablingMode then if Parent<>nil
       then Result := Result and Parent.Enabled;

    if Assigned(FOnGetEnabled) then FOnGetEnabled(Self, Result);
  end;
end;

function TEnLabel.GetFEnabled: boolean;
begin
  Result := inherited GetEnabled;
end;

end.
